Subject: Re: [patch 2.6.13 0/5] normalize calculations of rx_dropped

From: "John W. Linville" <[email-masked]>
Date: Mon, 24 Oct 2005 17:57:53 -0400

On Mon, Oct 24, 2005 at 02:35:42PM -0700, Ben Greear wrote:

> It doesn't matter too much to me either way, but I'd like for there to
> be a precisely documented definition for the various net-stats so that
> I can correctly show the values to user-space (I can certainly add 
> rx_discards
> to rx_errors for a 'total rx errors' value, but I need to know whether
> rx_discards is already in rx_errors to keep from counting things twice.)

My opinion is that:

	-- rx_errors should count all "on the wire" hardware errors;

	-- rx_missed_errors should count frames w/ no "on the wire"
	errors that cannot be received by the hardware (generally
	due to lack of DMA bufers); and,

	-- rx_discards should count frames dropped by the kernel
	after successful reception by the hardware.

I do _not_ think rx_missed_errors should be counted as part of
rx_errors, but I could be persuaded otherwise.

> Jeff:  Could you lay down the law somewhere in the Documentation/
> directory and then let us start fixing any driver that does it differently?

It does seem like a netdev stats clarification doc would be
appropriate.  Does anyone have the beginnings of this?

John
-- 
John W. Linville
[email-masked]